# You Don't Know JS: ES6 & Beyond

## Table of Contents

* Foreword
* Preface
* Chapter 1: ES? Now & Future
	* Versioning
	* Transpiling
* Chapter 2: Syntax
	* Block-Scoped Declarations
	* Spread / Rest
	* Default Parameter Values
	* Destructuring
	* Object Literal Extensions
	* Template Literals
	* Arrow Functions
	* `for..of` Loops
	* Regular Expression Extensions
	* Number Literal Extensions
	* Unicode
	* Symbols
* Chapter 3: Organization
	* Iterators
	* Generators
	* Modules
	* Classes
* Chapter 4: Async Flow Control
	* Promises
	* Generators + Promises
* Chapter 5: Collections
	* TypedArrays
	* Maps
	* WeakMaps
	* Sets
	* WeakSets
* Chapter 6: API Additions
	* `Array`
	* `Object`
	* `Math`
	* `Number`
	* `String`
* Chapter 7: Meta Programming
	* Function Names
	* Meta Properties
	* Well Known Symbols
	* Proxies
	* `Reflect` API
	* Feature Testing
	* Tail Call Optimization (TCO)
* Chapter 8: Beyond ES6
	* `async function`s
	* `Object.observe(..)`
	* Exponentiation Operator
	* Object Properties and `...`
	* `Array#includes(..)`
	* SIMD
* Appendix A: Acknowledgments
